=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2008-10-01 22:23:24 +0000
+++ loggerhead/controllers/inventory_ui.py	2008-10-01 20:15:37 +0000
@@ -20,7 +20,7 @@
 import logging
 import posixpath
 
-from paste.httpexceptions import HTTPServerError
+from paste.httpexceptions import HTTPNotFound, HTTPServerError
 
 from bzrlib.revision import is_null as is_null_rev
 
@@ -47,58 +47,49 @@
         else:
             revid = h.last_revid
 
+        if is_null_rev(revid):
+            #XXX: try to print a nicer error without throwing an exception.
+            raise HTTPNotFound('This branch does not have any revisions yet.')
+
+        try:
+            inv = h.get_inventory(revid)
+        except:
+            self.log.exception('Exception fetching changes')
+            raise HTTPServerError('Could not fetch changes')
+
+        file_id = kw.get('file_id', inv.root.file_id)
+        start_revid = kw.get('start_revid', None)
+        sort_type = kw.get('sort', None)
+
         # no navbar for revisions
         navigation = util.Container()
+
+        change = h.get_changes([ revid ])[0]
+        # add parent & merge-point branch-nick info, in case it's useful
+        h.get_branch_nicks([ change ])
+
+        path = inv.id2path(file_id)
+        if not path.startswith('/'):
+            path = '/' + path
+        idpath = inv.get_idpath(file_id)
+        if len(idpath) > 1:
+            updir = dirname(path)
+            updir_file_id = idpath[-2]
+        else:
+            updir = None
+            updir_file_id = None
+        if updir == '/':
+            updir_file_id = None
+
         # Directory Breadcrumbs
         directory_breadcrumbs = util.directory_breadcrumbs(
                 self._branch.friendly_name,
                 self._branch.is_root,
                 'files')
 
-        if not is_null_rev(revid):
-            try:
-                inv = h.get_inventory(revid)
-            except:
-                self.log.exception('Exception fetching changes')
-                raise HTTPServerError('Could not fetch changes')
-
-            file_id = kw.get('file_id', inv.root.file_id)
-            start_revid = kw.get('start_revid', None)
-            sort_type = kw.get('sort', None)
-
-            change = h.get_changes([ revid ])[0]
-            # add parent & merge-point branch-nick info, in case it's useful
-            h.get_branch_nicks([ change ])
-
-            path = inv.id2path(file_id)
-            if not path.startswith('/'):
-                path = '/' + path
-            idpath = inv.get_idpath(file_id)
-            if len(idpath) > 1:
-                updir = dirname(path)
-                updir_file_id = idpath[-2]
-            else:
-                updir = None
-                updir_file_id = None
-            if updir == '/':
-                updir_file_id = None
-
-            # Create breadcrumb trail for the path within the branch
-            branch_breadcrumbs = util.branch_breadcrumbs(path, inv, 'files')
-            filelist = h.get_filelist(inv, file_id, sort_type)
-        else:
-            inv = None
-            file_id = None
-            start_revid = None
-            sort_type = None
-            change = None
-            path = "/"
-            idpath = None
-            updir = None
-            updir_file_id = None
-            branch_breadcrumbs = []
-            filelist = []
-
+        # Create breadcrumb trail for the path within the branch
+        branch_breadcrumbs = util.branch_breadcrumbs(path, inv, 'files')
+        
         return {
             'branch': self._branch,
             'util': util,
@@ -108,7 +99,7 @@
             'path': path,
             'updir': updir,
             'updir_file_id': updir_file_id,
-            'filelist': filelist,
+            'filelist': h.get_filelist(inv, file_id, sort_type),
             'history': h,
             'posixpath': posixpath,
             'navigation': navigation,

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2008-10-01 22:20:26 +0000
+++ loggerhead/templates/changelog.pt	2008-09-09 22:47:45 +0000
@@ -23,14 +23,10 @@
            <tal:no-link condition="not: branch/branch_link">
              <span metal:use-macro="breadcrumbs/directory"></span>
            </tal:no-link>
-           <tal:block condition="changes">
-             : changes
-             <tal:block condition="filter_file_id">to <span tal:content="python:history.get_path(revid, filter_file_id)" /></tal:block>
-             <tal:block condition="start_revid">from revision
-               <span tal:content="python:history.get_revno(start_revid)"/>
-             </tal:block>
-             <tal:block condition="query">matching <tal:block content="query" /></tal:block>
-           </tal:block>
+           : changes
+          <tal:block condition="filter_file_id">to <span tal:content="python:history.get_path(revid, filter_file_id)" /></tal:block>
+          <tal:block condition="start_revid">from revision <tal:block content="python:history.get_revno(start_revid)" /></tal:block>
+          <tal:block condition="query">matching <tal:block content="query" /></tal:block>
          </h1>
         </tal:block>
 

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2008-10-01 22:15:10 +0000
+++ loggerhead/templates/inventory.pt	2008-08-16 04:57:38 +0000
@@ -20,130 +20,123 @@
       <span tal:condition="not: branch/branch_link">
         <span metal:use-macro="breadcrumbs/directory" />
       </span>
-      <tal:block condition="python:change">
-        : viewing
-        <span metal:use-macro="breadcrumbs/branch" />
-        for revision <span tal:content="change/revno"/>
-      </tal:block>
+      : viewing
+      <span metal:use-macro="breadcrumbs/branch" />
+      for revision <span tal:content="change/revno"/>
     </h1>
 
     <div metal:fill-slot="content">
-        <p tal:condition="python:not change">
-          No revisions!
-        </p>
-        <p tal:condition="python:change">
-          <ul id="submenuTabs">
-              <li id="first">
-                  <a tal:attributes="href python:url(['/revision', change.revno], clear=1, start_revid=change.revno)">view revision</a>
-              </li>
-              <li id="last">
-                  <a tal:attributes="href python:url(['/changes', change.revno], clear=1, start_revid=change.revno)">view branch changes</a>
-              </li>
-          </ul>
-
-          <tal:revision-info replace="structure python:revisioninfo(url, branch, change)" />
-
-          <table id="logentries">
-            <tr class="logheader">
-              <th class="summarycell"><a tal:attributes="href python:url(['/files', revid], sort='filename')">Filename</a></th>
-              <th class="datecell">Latest Rev</th>
-              <th class="datecell"><a tal:attributes="href python:url(['/files', revid], sort='date')">Last Changed</a></th>
-              <th class="timedate"><a tal:attributes="href python:url(['/files', revid], sort='size')">Size</a></th>
-              <th class="expandcell"></th>
-              <th class="expandcell"></th>
-            </tr>
-
-            <tr class="blueRow0" tal:condition="python:updir">
-                <td class="summcell" colspan="6">
-                    <a tal:attributes="href python:url(['/files', revid], file_id=updir_file_id)" class="link">
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_folder_up.gif')" />..</a>
-                </td>
-            </tr>
-
-            <!-- Show this if it's a directory -->
-            <tal:block repeat="file filelist">
-            <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='directory'">
-                <td class="autcell"><a tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)">
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_folder.gif');
-                                             title string:Go to ${file/filename}" />
-                    </a>
-
-                 <a tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)" 
-                                        tal:content="file/filename" class="link"></a>
-                 </td>
-                 <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
-                                                     title string:Show revision ${file/change/revno}"
-                                     tal:content="file/change/revno"></a>
-                 </td>
-                 <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
-                 <td class="timedate2"></td>
-                 <td class="expcell"><a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_file_id=file.file_id);
-                                                     title string:Show revision ${file/change/revno}">
-                                      <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
-                                     </a>
-              </td>
-                <td class="expcell"></td>
-            </tr>
-
-            <!-- Show this if it's a symlink -->
-            <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='symlink'">
-                <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)">
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_flecha.gif')" alt="Symlink" />
-                    </a>
-
-                 <a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)" 
-                                        tal:content="file/filename" class="link"></a>
-                 </td>
-                 <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
-                                                     title string:Show revision ${file/change/revno}"
-                                     tal:content="file/change/revno"></a>
-                 </td>
-                 <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
-                 <td class="timedate2">.</td>
-                 <td class="expcell"><a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_file_id=file.file_id);
-                                                        title string:Show revision ${file/change/revno}">
-                                          <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif');
-                                                               title string:Show revision ${file/change/revno}" />
-                                     </a>
-              </td>
-                <td class="expcell"></td>
-            </tr>
-
-            <!-- Show this if it's a regular file -->
-            <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='file'">
-                <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)">
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file.gif');
-                                             title string:Annotate ${file/filename}"
-                             tal:condition="python:file.executable is False" />
-                        <!-- Show a different icon id the file executable -->
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif'); 
-                                             title string:Annotate ${file/filename}"
-                             tal:condition="python:file.executable is True" alt="File" />
-                    </a>
-
-              <a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)"
-                                     tal:content="file/filename" class="link"></a></td>
-              <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
-                                                  title string:Show revision ${file/change/revno}"
-                                  tal:content="file/change/revno"></a>
-              </td>
-              <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
-              <td class="timedate2" tal:content="python:util.human_size(file.size)"></td>
-              <td class="expcell"><a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id);
-                                                     title string:Annotate ${file/filename}">
-                                      <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
-                                     </a>
-              </td>
-              <td class="expcell">
-                 <a tal:attributes="href python:url(['/download', file.revid, file.file_id, file.filename]);
-                                    title string:Download ${file/filename} at revision ${file/change/revno}">
-                   <img tal:attributes="src python:branch.static_url('/static/images/ico_file_download.gif')" alt="Download File" />
-                 </a>
-              </td>
-           </tr>
-          </tal:block>
-        </table>
-      </p>
+        <ul id="submenuTabs">
+            <li id="first">
+                <a tal:attributes="href python:url(['/revision', change.revno], clear=1, start_revid=change.revno)">view revision</a>
+            </li>
+            <li id="last">
+                <a tal:attributes="href python:url(['/changes', change.revno], clear=1, start_revid=change.revno)">view branch changes</a>
+            </li>
+        </ul>
+
+      <tal:revision-info replace="structure python:revisioninfo(url, branch, change)" />
+
+      <table id="logentries">
+          <tr class="logheader">
+            <th class="summarycell"><a tal:attributes="href python:url(['/files', revid], sort='filename')">Filename</a></th>
+            <th class="datecell">Latest Rev</th>
+            <th class="datecell"><a tal:attributes="href python:url(['/files', revid], sort='date')">Last Changed</a></th>
+            <th class="timedate"><a tal:attributes="href python:url(['/files', revid], sort='size')">Size</a></th>
+            <th class="expandcell"></th>
+            <th class="expandcell"></th>
+          </tr>
+
+          <tr class="blueRow0" tal:condition="python:updir">
+              <td class="summcell" colspan="6">
+                  <a tal:attributes="href python:url(['/files', revid], file_id=updir_file_id)" class="link">
+                      <img tal:attributes="src python:branch.static_url('/static/images/ico_folder_up.gif')" />..</a>
+              </td>
+          </tr>
+          
+          <!-- Show this if it's a directory --> 
+          <tal:block repeat="file filelist">
+          <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='directory'">
+              <td class="autcell"><a tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)">
+                      <img tal:attributes="src python:branch.static_url('/static/images/ico_folder.gif');
+                                           title string:Go to ${file/filename}" />
+                  </a>
+
+               <a tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)" 
+                                      tal:content="file/filename" class="link"></a>
+               </td>
+               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
+                                                   title string:Show revision ${file/change/revno}"
+                                   tal:content="file/change/revno"></a>
+               </td>
+               <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
+               <td class="timedate2"></td>
+               <td class="expcell"><a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_file_id=file.file_id);
+                                                   title string:Show revision ${file/change/revno}">
+                                    <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
+                                   </a>
+            </td>
+              <td class="expcell"></td>
+          </tr>
+          
+          <!-- Show this if it's a symlink --> 
+          <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='symlink'">
+              <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)">
+                      <img tal:attributes="src python:branch.static_url('/static/images/ico_flecha.gif')" alt="Symlink" />
+                  </a>
+
+               <a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)" 
+                                      tal:content="file/filename" class="link"></a>
+               </td>
+               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
+                                                   title string:Show revision ${file/change/revno}"
+                                   tal:content="file/change/revno"></a>
+               </td>
+               <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
+               <td class="timedate2">.</td>
+               <td class="expcell"><a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_file_id=file.file_id);
+                                                      title string:Show revision ${file/change/revno}">
+                                        <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif');
+                                                             title string:Show revision ${file/change/revno}" />
+                                   </a>
+            </td>
+              <td class="expcell"></td>
+          </tr>
+
+          <!-- Show this if it's a regular file --> 
+          <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='file'">
+              <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)">
+                      <img tal:attributes="src python:branch.static_url('/static/images/ico_file.gif');
+                                           title string:Annotate ${file/filename}"
+                           tal:condition="python:file.executable is False" />
+                      <!-- Show a different icon id the file executable -->
+                      <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif'); 
+                                           title string:Annotate ${file/filename}"
+                           tal:condition="python:file.executable is True" alt="File" />
+                  </a>
+
+            <a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)"
+                                   tal:content="file/filename" class="link"></a></td>
+            <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
+                                                title string:Show revision ${file/change/revno}"
+                                tal:content="file/change/revno"></a>
+            </td>
+            <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
+            <td class="timedate2" tal:content="python:util.human_size(file.size)"></td>
+            <td class="expcell"><a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id);
+                                                   title string:Annotate ${file/filename}">
+                                    <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
+                                   </a>
+            </td>
+            <td class="expcell">
+               <a tal:attributes="href python:url(['/download', file.revid, file.file_id, file.filename]);
+                                  title string:Download ${file/filename} at revision ${file/change/revno}">
+                 <img tal:attributes="src python:branch.static_url('/static/images/ico_file_download.gif')" alt="Download File" />
+               </a>
+            </td>
+         </tr>
+        </tal:block>
+      </table>
     </div>
   </body>
 </html>

